/*
    This program does not do any of the task work.

    The main() function creates the worker (child)
    processes and passes to them the command line
    parameters that they need.

    The processWorker-child-io.c and processWorker-child-calc.c
    programs do the task work.

    This program uses the Timing.h functions to keep fairly
    accurate timing information.
*/
#include "constants.h"
#include "printError.h"
#include "Timing.h"
#include <stdio.h>
#include <windows.h>

int main(int argc, char *argv[])
{
   #define NUMBER_OF_IO_PROCESSES    NUMBER_OF_IO_TASKS
   #define NUMBER_OF_CALC_PROCESSES  NUMBER_OF_CALC_TASKS
   #define NUMBER_OF_PROCESSES  NUMBER_OF_IO_PROCESSES + NUMBER_OF_CALC_TASKS

   STARTUPINFO startInfo;
   PROCESS_INFORMATION processInfo[NUMBER_OF_PROCESSES];
   HANDLE lpHandles[NUMBER_OF_PROCESSES];

   char commandLine[LENGTH_OF_COMMAND_LINES];
   int processCount, n;

   TimingObject startTime, endTime, elapsedTime;

   processCount = 0;

   /* keep track of when we start working */
   getThreadTime(&startTime);

   /* this loop creates all of the I/O tasks */
   for (n = 0; n < NUMBER_OF_IO_PROCESSES; n++)
   {
      // Create a command line that randomly chooses one of the
      // ten input files, data0.txt through data9.txt, and
      // sequentially numbers the output files as output?.txt
      // where ? is an integer from 1 to NUMBER_OF_IO_PROCESSES.

      // Use CreateProcess, and the constructed command line, to
      // create a child (worker) process. Be sure to error check
      // the call to CreateProcess and you will need to keep track
      // of the process handle returned by CreateProcess (it is
      // needed by WaitForMultipleObjects()).

      // Note: You may want to log some information to the console
      // to help you see what is going on (but don't do any logging
      // from the child process).
   }

   /* this loop create all of the compute tasks */
   for (n = 0; n < NUMBER_OF_CALC_PROCESSES; n++)
   {
      // Create a command line that randomly chooses a multiplier
      // to pass to the child compute process.

      // Use CreateProcess, and the constructed command line, to
      // create a child (worker) process. Be sure to error check
      // the call to CreateProcess, and you will need to keep track
      // of the process handle returned by CreateProcess (it is
      // needed by WaitForMultipleObjects()).

      // Note: You may want to log some information to the console
      // to help you see what is going on (but don't do any logging
      // from the child process).
   }

   /* wait for all child processes to end */
   printf("  waiting for child processes to complete...");
   // NOTE: WaitForMultipleObjects() can only wait on a maximum of 64 objects.
   // To wait on more than 64 processes you need to call WaitForMultipleObjects()
   // several times. If 64 < processCount <= 128, call WaitForMultipleObjects()
   // first with 64 as the first paramenter and lpHandles as the second parameter,
   // then call WaitForMultipleObjects() a second time with processCount-64 as the
   // first parameter and with lpHandles+64 as the second parameter. Similarly if
   // processCount > 128. In other words, you need to "walk" through the lpHandles[]
   // array in steps of 64. Also, the calls to WaitForMultipleObjects() should be
   // error checked.
   //WaitForMultipleObjects(processCount, lpHandles, TRUE, INFINITE);
   printf("\nAll processes completed.\n");

   /* determine when we finish working */
   getThreadTime(&endTime);
   computeElapsedTime(&startTime, &endTime, &elapsedTime);
   printTimingObject(&elapsedTime);

   for (n = 0; n < processCount; n++)
   {
      printProcessTimes(lpHandles[n]);
   }

   return 0;
}
